<template>
    <v-container fluid>
        <v-form fast-fail @submit.prevent="AddRoles" class="custom">
            <v-row>
                <v-col cols="6" md="3">
                    <div class="custom-label">Adı </div><br>
                    <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactForm.name" />
                    <div class="custom-label">Açıklama </div><br>
                    <v-text-field class="text-eureko" :disabled="false" v-model="reactForm.description" variant="outlined" />
                </v-col>
                <v-col  cols="6" md="3">
                    <div class="custom-label">Görünen Adı </div><br>
                    <v-text-field class="text-eureko" :disabled="false" v-model="reactForm.displayText" variant="outlined" />
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" md="12" justify="end" class="text-right">
                    <custom-button style="width: 120px;" color="primary" size="medium" val="Kaydet" @click="AddRoles" />
                </v-col>
            </v-row>
        </v-form>
        <AlertComponent :title="this.alert.title" :alert-text="this.alert.alertText" :alert-type="this.alert.alertType"   ref="alertComponentRef" />
    </v-container>
</template>

<script>
import  RoleService  from "@/services/RoleService";
import  CustomButton  from '@/components/custom-controller/CustomButton.vue';
import { reactive, ref } from "vue";
import AlertComponent from '@/components/alert-component/AlertComponent.vue';
import eventBus from '@/plugins/eventBus';
export default {
    name: "RollAdd",
    components: {
        CustomButton,
        AlertComponent
    },
    setup() {
        const alertComponentRef = ref(null);
      
        const reactForm = reactive({
            name: "",
            description: "",
            displayText: ""
        });
        const alert = reactive({
            title: "",
            alertText: "",
            alertType: ""
        });
        const AddRoles = () => {
            const request = {
                name: reactForm.name,
                description: reactForm.description,
                displayText: reactForm.displayText
            };
             RoleService.AddRole(request)
                .then(() => {
                    alert.title = "Başarılı";
                    alert.alertText = "Yetki başarılı şekilde eklenmiştir";
                    alert.alertType = "success";
                    alertComponentRef.value.showTimedAlert();
                    localStorage.removeItem("roles");
                    eventBus.emit('role-added');
                })
                .catch((error) => {
                    alert.title = "Başarısız";
                    alert.alertText = "Yetki Eklenirken bir hata oluştu. Hata : "+error.ErrorMessage;
                    alert.alertType = "error";
                    alertComponentRef.value.showTimedAlert();
                });
        };

        return {
            alertComponentRef,
            reactForm,
            alert,
            AddRoles
        };

    },
};
</script>

<style scoped>
@import "@/assets/styles/custom/custom-input.css";
</style>
